//
// Copyright (c) 2008 smdn <smdn@smdn.jp>
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Smdn.Net.Imap4.Client {
  partial class ImapMessage {
    /*
     * OpenRead()
     */
    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(CancellationToken cancellationToken)
      => Body.Download();

    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.Download(progress: progress);

    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(CancellationToken cancellationToken,
                           IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.Download(cancellationToken: cancellationToken, progress: progress);

    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(ImapMessageFetchBodyOptions options,
                           CancellationToken cancellationToken)
      => Body.Download(options: options, cancellationToken: cancellationToken);

    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(ImapMessageFetchBodyOptions options,
                           IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.Download(options: options, progress: progress);

    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(ImapMessageFetchBodyOptions options,
                           CancellationToken cancellationToken,
                           IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.Download(options: options, cancellationToken: cancellationToken, progress: progress);

    /*
     * OpenReadAsync()
     */
    [Obsolete("use Body.ReadAsync(Action<Stream>) or Body.DownloadAsync() instead")]
    public Task<Stream> OpenReadAsync()
      => Body.DownloadAsync();

    [Obsolete("use Body.ReadAsync(Action<Stream>) or Body.DownloadAsync() instead")]
    public Task<Stream> OpenReadAsync(CancellationToken cancellationToken)
      => Body.DownloadAsync(cancellationToken: cancellationToken);

    [Obsolete("use Body.ReadAsync(Action<Stream>) or Body.DownloadAsync() instead")]
    public Task<Stream> OpenReadAsync(IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.DownloadAsync(progress: progress);

    [Obsolete("use Body.ReadAsync(Action<Stream>) or Body.DownloadAsync() instead")]
    public Task<Stream> OpenReadAsync(CancellationToken cancellationToken,
                                      IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.DownloadAsync(cancellationToken: cancellationToken, progress: progress);

    [Obsolete("use Body.ReadAsync(Action<Stream>) or Body.DownloadAsync() instead")]
    public Task<Stream> OpenReadAsync(ImapMessageFetchBodyOptions options)
      => Body.DownloadAsync(options: options);

    [Obsolete("use Body.ReadAsync(Action<Stream>) or Body.DownloadAsync() instead")]
    public Task<Stream> OpenReadAsync(ImapMessageFetchBodyOptions options,
                                      CancellationToken cancellationToken)
      => Body.DownloadAsync(options: options, cancellationToken: cancellationToken);

    [Obsolete("use Body.ReadAsync(Action<Stream>) or Body.DownloadAsync() instead")]
    public Task<Stream> OpenReadAsync(ImapMessageFetchBodyOptions options,
                                      IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.DownloadAsync(options: options, progress: progress);

    [Obsolete("use Body.ReadAsync(Action<Stream>) or Body.DownloadAsync() instead")]
    public Task<Stream> OpenReadAsync(ImapMessageFetchBodyOptions options,
                                      CancellationToken cancellationToken,
                                      IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.DownloadAsync(options: options, cancellationToken: cancellationToken, progress: progress);

    /*
     * ReadAsAsync<TResult>(Converter<Stream>)
     */
    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Converter<Stream, TResult> converter)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)));

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Converter<Stream, TResult> converter,
                                              CancellationToken cancellationToken)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), cancellationToken: cancellationToken);

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Converter<Stream, TResult> converter,
                                              IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), progress: progress);

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Converter<Stream, TResult> converter,
                                              CancellationToken cancellationToken,
                                              IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), cancellationToken: cancellationToken, progress: progress);

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(ImapMessageFetchBodyOptions options,
                                              Converter<Stream, TResult> converter)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options);

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(ImapMessageFetchBodyOptions options,
                                              Converter<Stream, TResult> converter,
                                              CancellationToken cancellationToken)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options: options, cancellationToken: cancellationToken);

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(ImapMessageFetchBodyOptions options,
                                              Converter<Stream, TResult> converter,
                                              IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options: options, progress: progress);

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(ImapMessageFetchBodyOptions options,
                                              Converter<Stream, TResult> converter,
                                              CancellationToken cancellationToken,
                                              IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options: options, cancellationToken: cancellationToken, progress: progress);

    [Obsolete]
    internal static Task<TResult> ReadAsAsyncConverter<TResult>(Stream stream, Converter<Stream, TResult> converter)
      => Task.FromResult(converter(stream));

    /*
     * ReadAsAsync<TResult>(Func<Stream, ...>)
     */

    /*
     * ReadAllBytesAsync()
     */
    [Obsolete("use Body.ReadAsByteArrayAsync() instead")]
    public Task<byte[]> ReadAllBytesAsync()
      => Body.ReadAsByteArrayAsync();

    [Obsolete("use Body.ReadAsByteArrayAsync() instead")]
    public Task<byte[]> ReadAllBytesAsync(CancellationToken cancellationToken)
      => Body.ReadAsByteArrayAsync(cancellationToken: cancellationToken);

    [Obsolete("use Body.ReadAsByteArrayAsync() instead")]
    public Task<byte[]> ReadAllBytesAsync(IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsByteArrayAsync(progress: progress);

    [Obsolete("use Body.ReadAsByteArrayAsync() instead")]
    public Task<byte[]> ReadAllBytesAsync(CancellationToken cancellationToken,
                                          IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsByteArrayAsync(cancellationToken: cancellationToken, progress: progress);

    [Obsolete("use Body.ReadAsByteArrayAsync() instead")]
    public Task<byte[]> ReadAllBytesAsync(ImapMessageFetchBodyOptions options)
      => Body.ReadAsByteArrayAsync(options: options);

    [Obsolete("use Body.ReadAsByteArrayAsync() instead")]
    public Task<byte[]> ReadAllBytesAsync(ImapMessageFetchBodyOptions options,
                                          CancellationToken cancellationToken)
      => Body.ReadAsByteArrayAsync(options: options, cancellationToken: cancellationToken);

    [Obsolete("use Body.ReadAsByteArrayAsync() instead")]
    public Task<byte[]> ReadAllBytesAsync(ImapMessageFetchBodyOptions options,
                                          IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsByteArrayAsync(options: options, progress: progress);

    [Obsolete("use Body.ReadAsByteArrayAsync() instead")]
    public Task<byte[]> ReadAllBytesAsync(ImapMessageFetchBodyOptions options,
                                          CancellationToken cancellationToken,
                                          IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsByteArrayAsync(options: options, cancellationToken: cancellationToken, progress: progress);

    /*
     * WriteToAsync(Stream)
     */
    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(Stream stream)
      => Body.WriteToAsync(stream);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(Stream stream,
                             CancellationToken cancellationToken)
      => Body.WriteToAsync(stream, cancellationToken: cancellationToken);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(Stream stream,
                             IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.WriteToAsync(stream, progress: progress);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(Stream stream,
                             CancellationToken cancellationToken,
                             IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.WriteToAsync(stream, cancellationToken: cancellationToken, progress: progress);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(Stream stream,
                             ImapMessageFetchBodyOptions options)
      => Body.WriteToAsync(stream, options: options);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(Stream stream,
                             ImapMessageFetchBodyOptions options,
                             CancellationToken cancellationToken)
      => Body.WriteToAsync(stream, options: options, cancellationToken: cancellationToken);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(Stream stream,
                             ImapMessageFetchBodyOptions options,
                             IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.WriteToAsync(stream, options: options, progress: progress);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(Stream stream,
                             ImapMessageFetchBodyOptions options,
                             CancellationToken cancellationToken,
                             IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.WriteToAsync(stream, options: options, cancellationToken: cancellationToken, progress: progress);

    /*
     * WriteToAsync(BinaryWriter)
     */
    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(BinaryWriter writer)
      => Body.WriteToAsync(writer);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(BinaryWriter writer,
                             CancellationToken cancellationToken)
      => Body.WriteToAsync(writer, cancellationToken: cancellationToken);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(BinaryWriter writer,
                             IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.WriteToAsync(writer, progress: progress);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(BinaryWriter writer,
                             CancellationToken cancellationToken,
                             IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.WriteToAsync(writer, cancellationToken: cancellationToken, progress: progress);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(BinaryWriter writer,
                             ImapMessageFetchBodyOptions options)
      => Body.WriteToAsync(writer, options: options);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(BinaryWriter writer,
                             ImapMessageFetchBodyOptions options,
                             CancellationToken cancellationToken)
      => Body.WriteToAsync(writer, options: options, cancellationToken: cancellationToken);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(BinaryWriter writer,
                             ImapMessageFetchBodyOptions options,
                             IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.WriteToAsync(writer, options: options, progress: progress);

    [Obsolete("use Body.WriteToAsync() instead")]
    public Task WriteToAsync(BinaryWriter writer,
                             ImapMessageFetchBodyOptions options,
                             CancellationToken cancellationToken,
                             IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.WriteToAsync(writer, options: options, cancellationToken: cancellationToken, progress: progress);

    /*
     * SaveAsync()
     */
    [Obsolete("use Body.SaveAsync() instead")]
    public Task SaveAsync(string path)
      => Body.SaveAsync(path);

    [Obsolete("use Body.SaveAsync() instead")]
    public Task SaveAsync(string path,
                          CancellationToken cancellationToken)
      => Body.SaveAsync(path, cancellationToken: cancellationToken);

    [Obsolete("use Body.SaveAsync() instead")]
    public Task SaveAsync(string path,
                          IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.SaveAsync(path, progress: progress);

    [Obsolete("use Body.SaveAsync() instead")]
    public Task SaveAsync(string path,
                          CancellationToken cancellationToken,
                          IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.SaveAsync(path, cancellationToken: cancellationToken, progress: progress);

    [Obsolete("use Body.SaveAsync() instead")]
    public Task SaveAsync(string path,
                          ImapMessageFetchBodyOptions options)
      => Body.SaveAsync(path, options: options);

    [Obsolete("use Body.SaveAsync() instead")]
    public Task SaveAsync(string path,
                          ImapMessageFetchBodyOptions options,
                          CancellationToken cancellationToken)
      => Body.SaveAsync(path, options: options, cancellationToken: cancellationToken);

    [Obsolete("use Body.SaveAsync() instead")]
    public Task SaveAsync(string path,
                          ImapMessageFetchBodyOptions options,
                          IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.SaveAsync(path, options: options, progress: progress);

    [Obsolete("use Body.SaveAsync() instead")]
    public Task SaveAsync(string path,
                          ImapMessageFetchBodyOptions options,
                          CancellationToken cancellationToken,
                          IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.SaveAsync(path, options: options, cancellationToken: cancellationToken, progress: progress);

    /*
     * DownloadAsync()
     */
    [Obsolete("use Body.DownloadAsync() instead")]
    public Task<Stream> DownloadAsync()
      => Body.DownloadAsync();

    [Obsolete("use Body.DownloadAsync() instead")]
    public Task<Stream> DownloadAsync(CancellationToken cancellationToken)
      => Body.DownloadAsync(cancellationToken: cancellationToken);

    [Obsolete("use Body.DownloadAsync() instead")]
    public Task<Stream> DownloadAsync(IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.DownloadAsync(progress: progress);

    [Obsolete("use Body.DownloadAsync() instead")]
    public Task<Stream> DownloadAsync(CancellationToken cancellationToken,
                                      IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.DownloadAsync(cancellationToken: cancellationToken, progress: progress);

    [Obsolete("use Body.DownloadAsync() instead")]
    public Task<Stream> DownloadAsync(ImapMessageFetchBodyOptions options)
      => Body.DownloadAsync(options: options);

    [Obsolete("use Body.DownloadAsync() instead")]
    public Task<Stream> DownloadAsync(ImapMessageFetchBodyOptions options,
                                      CancellationToken cancellationToken)
      => Body.DownloadAsync(options: options, cancellationToken: cancellationToken);

    [Obsolete("use Body.DownloadAsync() instead")]
    public Task<Stream> DownloadAsync(ImapMessageFetchBodyOptions options,
                                      IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.DownloadAsync(options: options, progress: progress);

    [Obsolete("use Body.DownloadAsync() instead")]
    public Task<Stream> DownloadAsync(ImapMessageFetchBodyOptions options,
                                      CancellationToken cancellationToken,
                                      IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.DownloadAsync(options: options, cancellationToken: cancellationToken, progress: progress);

    /*
     * OpenTextAsync()
     */
    [Obsolete("use Body.ReadAsync(Action<StreamReader>) or Body.ReadAsStringAsync() instead")]
    public Task<StreamReader> OpenTextAsync()
      => Body.ReadAsAsync(OpenTextAsyncConverter, arg: default(int), forceCharsetTo: ImapMessageBodyBase.DefaultCharset);

    [Obsolete("use Body.ReadAsync(Action<StreamReader>) or Body.ReadAsStringAsync() instead")]
    public Task<StreamReader> OpenTextAsync(Encoding charset)
      => Body.ReadAsAsync(OpenTextAsyncConverter, arg: default(int), forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsync(Action<StreamReader>) or Body.ReadAsStringAsync() instead")]
    public Task<StreamReader> OpenTextAsync(ImapMessageFetchBodyOptions options)
      => Body.ReadAsAsync(OpenTextAsyncConverter, arg: default(int), options: options, forceCharsetTo: ImapMessageBodyBase.DefaultCharset);

    [Obsolete("use Body.ReadAsync(Action<StreamReader>) or Body.ReadAsStringAsync() instead")]
    public Task<StreamReader> OpenTextAsync(Encoding charset,
                                            ImapMessageFetchBodyOptions options)
      => Body.ReadAsAsync(OpenTextAsyncConverter, arg: default(int), options: options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsync(Action<StreamReader>) or Body.ReadAsStringAsync() instead")]
    public Task<StreamReader> OpenTextAsync(Encoding charset,
                                            ImapMessageFetchBodyOptions options,
                                            CancellationToken cancellationToken)
      => Body.ReadAsAsync(OpenTextAsyncConverter, arg: default(int), options: options, cancellationToken: cancellationToken, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsync(Action<StreamReader>) or Body.ReadAsStringAsync() instead")]
    public Task<StreamReader> OpenTextAsync(Encoding charset,
                                            ImapMessageFetchBodyOptions options,
                                            IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsAsync(OpenTextAsyncConverter, arg: default(int), options: options, progress: progress, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsync(Action<StreamReader>) or Body.ReadAsStringAsync() instead")]
    public Task<StreamReader> OpenTextAsync(Encoding charset,
                                            ImapMessageFetchBodyOptions options,
                                            CancellationToken cancellationToken,
                                            IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsAsync(OpenTextAsyncConverter, arg: default(int), options: options, cancellationToken: cancellationToken, progress: progress, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete]
    internal static async Task<StreamReader> OpenTextAsyncConverter(Stream bodyStream, Encoding contentCharset, int _)
      => new StreamReader(await ImapMessageBody.DownloadAsync(bodyStream).ConfigureAwait(false), contentCharset); // TODO: remove ImapMessageBody.DownloadAsync

    /*
     * ReadAsAsync<TResult>(Converter<StreamReader>)
     */
    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Converter<StreamReader, TResult> converter)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)));

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Encoding charset,
                                              Converter<StreamReader, TResult> converter)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(ImapMessageFetchBodyOptions options,
                                              Converter<StreamReader, TResult> converter)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options: options);

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Encoding charset,
                                              ImapMessageFetchBodyOptions options,
                                              Converter<StreamReader, TResult> converter)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options: options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Encoding charset,
                                              ImapMessageFetchBodyOptions options,
                                              Converter<StreamReader, TResult> converter,
                                              CancellationToken cancellationToken)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options: options, cancellationToken: cancellationToken, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Encoding charset,
                                              ImapMessageFetchBodyOptions options,
                                              Converter<StreamReader, TResult> converter,
                                              IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options: options, progress: progress, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsAsync() instead")]
    public Task<TResult> ReadAsAsync<TResult>(Encoding charset,
                                              ImapMessageFetchBodyOptions options,
                                              Converter<StreamReader, TResult> converter,
                                              CancellationToken cancellationToken,
                                              IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsAsync(converter: ReadAsAsyncConverter, arg: converter ?? throw new ArgumentNullException(nameof(converter)), options: options, cancellationToken: cancellationToken, progress: progress, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete]
    internal static Task<TResult> ReadAsAsyncConverter<TResult>(StreamReader reader, Converter<StreamReader, TResult> converter)
      => Task.FromResult(converter(reader));

    /*
     * ReadAllLinesAsync()
     */
    [Obsolete("use Body.ReadAsStringLinesAsync() instead")]
    public Task<string[]> ReadAllLinesAsync()
      => ToArrayAsync(Body.ReadAsStringLinesAsync());

    [Obsolete("use Body.ReadAsStringLinesAsync() instead")]
    public Task<string[]> ReadAllLinesAsync(Encoding charset)
      => ToArrayAsync(Body.ReadAsStringLinesAsync(forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset))));

    [Obsolete("use Body.ReadAsStringLinesAsync() instead")]
    public Task<string[]> ReadAllLinesAsync(ImapMessageFetchBodyOptions options)
      => ToArrayAsync(Body.ReadAsStringLinesAsync(options: options));

    [Obsolete("use Body.ReadAsStringLinesAsync() instead")]
    public Task<string[]> ReadAllLinesAsync(Encoding charset,
                                            ImapMessageFetchBodyOptions options)
      => ToArrayAsync(Body.ReadAsStringLinesAsync(options: options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset))));

    [Obsolete("use Body.ReadAsStringLinesAsync() instead")]
    public Task<string[]> ReadAllLinesAsync(Encoding charset,
                                            ImapMessageFetchBodyOptions options,
                                            CancellationToken cancellationToken)
      => ToArrayAsync(Body.ReadAsStringLinesAsync(options: options, cancellationToken: cancellationToken, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset))));

    [Obsolete("use Body.ReadAsStringLinesAsync() instead")]
    public Task<string[]> ReadAllLinesAsync(Encoding charset,
                                            ImapMessageFetchBodyOptions options,
                                            IProgress<ImapMessageFetchProgressInfo> progress)
      => ToArrayAsync(Body.ReadAsStringLinesAsync(options: options, progress: progress, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset))));

    [Obsolete("use Body.ReadAsStringLinesAsync() instead")]
    public Task<string[]> ReadAllLinesAsync(Encoding charset,
                                            ImapMessageFetchBodyOptions options,
                                            CancellationToken cancellationToken,
                                            IProgress<ImapMessageFetchProgressInfo> progress)
      => ToArrayAsync(Body.ReadAsStringLinesAsync(options: options, cancellationToken: cancellationToken, progress: progress, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset))));

    [Obsolete]
    internal static async Task<string[]> ToArrayAsync(Task<IReadOnlyList<string>> task)
      => (await task.ConfigureAwait(false)).ToArray();

    /*
     * ReadAllTextAsync()
     */
    [Obsolete("use Body.ReadAsStringAsync() instead")]
    public Task<string> ReadAllTextAsync()
      => Body.ReadAsStringAsync();

    [Obsolete("use Body.ReadAsStringAsync() instead")]
    public Task<string> ReadAllTextAsync(Encoding charset)
      => Body.ReadAsStringAsync(forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsStringAsync() instead")]
    public Task<string> ReadAllTextAsync(ImapMessageFetchBodyOptions options)
      => Body.ReadAsStringAsync(options: options);

    [Obsolete("use Body.ReadAsStringAsync() instead")]
    public Task<string> ReadAllTextAsync(Encoding charset,
                                         ImapMessageFetchBodyOptions options)
      => Body.ReadAsStringAsync(options: options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsStringAsync() instead")]
    public Task<string> ReadAllTextAsync(Encoding charset,
                                         ImapMessageFetchBodyOptions options,
                                         CancellationToken cancellationToken)
      => Body.ReadAsStringAsync(options: options, cancellationToken: cancellationToken, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsStringAsync() instead")]
    public Task<string> ReadAllTextAsync(Encoding charset,
                                         ImapMessageFetchBodyOptions options,
                                         IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsStringAsync(options: options, progress: progress, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsStringAsync() instead")]
    public Task<string> ReadAllTextAsync(Encoding charset,
                                         ImapMessageFetchBodyOptions options,
                                         CancellationToken cancellationToken,
                                         IProgress<ImapMessageFetchProgressInfo> progress)
      => Body.ReadAsStringAsync(options: options, cancellationToken: cancellationToken, progress: progress, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    /*
     * GetRawHeaderAsync(), GetHeaderAsync()
     */
    [Obsolete("use Header.ReadAsStringAsync() instead")]
    public Task<string> GetRawHeaderAsync()
      => Header.ReadAsStringAsync();

    [Obsolete("use Header.ReadAsStringAsync() instead")]
    public Task<string> GetRawHeaderAsync(params string[] headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsStringAsync() : Header.ReadAsStringAsync(headerFields);

    [Obsolete("use Header.ReadAsStringAsync() instead")]
    public Task<string> GetRawHeaderAsync(/*params*/ IEnumerable<string> headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsStringAsync() : Header.ReadAsStringAsync(headerFields);

    [Obsolete("use Header.ReadAsNameValuePairsAsync() instead")]
    public Task<IReadOnlyList<KeyValuePair<string, string>>> GetHeaderAsync()
      => Header.ReadAsNameValuePairsAsync();

    [Obsolete("use Header.ReadAsNameValuePairsAsync() instead")]
    public Task<IReadOnlyList<KeyValuePair<string, string>>> GetHeaderAsync(params string[] headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsNameValuePairsAsync() : Header.ReadAsNameValuePairsAsync(headerFields: headerFields);

    [Obsolete("use Header.ReadAsNameValuePairsAsync() instead")]
    public Task<IReadOnlyList<KeyValuePair<string, string>>> GetHeaderAsync(bool decode,
                                                                            params string[] headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsNameValuePairsAsync(decodeHeaderFieldValues: decode) : Header.ReadAsNameValuePairsAsync(headerFields: headerFields, decodeHeaderFieldValues: decode);

    [Obsolete("use Header.ReadAsNameValuePairsAsync() instead")]
    public Task<IReadOnlyList<KeyValuePair<string, string>>> GetHeaderAsync(/*params*/ IEnumerable<string> headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsNameValuePairsAsync() : Header.ReadAsNameValuePairsAsync(headerFields: headerFields);

    [Obsolete("use Header.ReadAsNameValuePairsAsync() instead")]
    public Task<IReadOnlyList<KeyValuePair<string, string>>> GetHeaderAsync(bool decode,
                                                                            /*params*/ IEnumerable<string> headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsNameValuePairsAsync(decodeHeaderFieldValues: decode) : Header.ReadAsNameValuePairsAsync(headerFields: headerFields, decodeHeaderFieldValues: decode);
  }
}
