using System;
using NUnit.Framework;

using Smdn.Net.Imap4.Protocol.Strings;

namespace Smdn.Net.Imap4.Protocol {
  [TestFixture]
  public class ImapCompressionMechanismTests {
    [Test]
    public void TestEquals()
    {
      var x = ImapCompressionMechanism.Deflate;

      Assert.IsTrue(x.Equals(ImapCompressionMechanism.Deflate));
      Assert.IsTrue(x.Equals((object)"DEFLATE"));
      Assert.IsTrue(x.Equals((object)"deflate"));
      Assert.IsTrue(x.Equals((object)ImapCompressionMechanism.Deflate));
      Assert.IsTrue(x.Equals("DEFLATE"));
      Assert.IsTrue(x.Equals("deflate"));
      Assert.IsTrue(x.Equals(ImapCompressionMechanism.Deflate.ToString()));

      //Assert.IsFalse(x.Equals(ImapCompressionMechanism.Xxx));
      Assert.IsFalse(x.Equals((ImapString)ImapCompressionMechanism.Deflate.Value));
      Assert.IsFalse(x.Equals(new ImapCapability("DEFLATE")));
      Assert.IsFalse(x.Equals((object)new ImapCapability("DEFLATE")));
    }

    [Test]
    public void TestOpEquality()
    {
      var x = ImapCompressionMechanism.Deflate;

      Assert.IsTrue(x == ImapCompressionMechanism.Deflate);
      Assert.IsFalse(x != ImapCompressionMechanism.Deflate);

      //Assert.IsFalse(x == ImapCompressionMechanism.Xxx);
      //Assert.IsTrue(x != ImapCompressionMechanism.Xxx);
    }

    [Test]
    public void TestToString()
    {
      Assert.AreEqual("DEFLATE", ImapCompressionMechanism.Deflate.ToString());
    }

    [Test]
    public void TestSerializeBinary()
    {
      TestUtils.Assert.IsSerializableBinaryFormat(ImapCompressionMechanism.Deflate, deserialized => {
        Assert.AreNotSame(ImapCompressionMechanism.Deflate, deserialized);
        Assert.AreEqual(ImapCompressionMechanism.Deflate, deserialized);
      });
    }
  }
}
